## class FlashArrow : public Line

> An arrow with some kind of lightning flash.

## Inheritance:

### Public Methods

  | FlashArrow (ShapeView *s, Grafport *g, GShape *n1, GShape *n2, List<Point *> *line, bool Curved)
  | FlashArrow (ShapeView *v, Grafport *g, GShape *n1, GShape *n2, bool Curved)
  Shape* | Clone ()
  int | GetClassType () const

### Protected Methods

  void | DrawLine (const Point *ep1, const Point *ep2)
  void | DrawBezier (const Point *ep1, const Point *ep2)
  void | DrawLinePart ()

### Inherited from Line:

### Public Methods

bool IsCurved() const
void UpdateCurve(bool b)
void UpdatePosition(const Point *p, bool snap=True)
void SetPosition(const Point *p, bool snap=True)
void DrawOutLine(const Point *)
bool ContainsPt(int x, int y)
int HitHandles(int x, int y)
bool IsLine() const
unsigned int GetCount() const
unsigned int GetOrder() const
void SetOrder(unsigned int i)
void SetCount(unsigned int i)
GShape* GetFromShape() const
GShape* GetToShape() const
void SetFromShape(GShape *n)
void SetToShape(GShape *n)
unsigned int NrPoints() const
List <Point *> * GetLine() const
bool GetSegments(Point pt, Point *pt1, Point *pt2)
bool GetSegment(int n, Point *pt1, Point *pt2)
virtual bool InTextArea(int x, int y)
void SetEnd1(LineEnd::Type t)
void SetEnd2(LineEnd::Type t)
void UpdateEnd1(LineEnd::Type t)
void UpdateEnd2(LineEnd::Type t)
LineEnd::Type GetEnd1()
LineEnd::Type GetEnd2()
int GetLeftMost() const
int GetTopMost() const
int GetRightMost() const
int GetBottomMost() const
void SetToTop()
void SetFromTop()
void SetToBottom()
void SetFromBottom()
void UpdatePosition()
virtual void CalcPosition()
virtual void CalcEndPoints()
void CalcDirection()
bool CalcEndPoint(const Point *pt, unsigned which)
void SetPoint(const Point *pt, unsigned int n)
void AddPoint(const Point *pt, unsigned int n)
void RemovePoint(unsigned int n)
void WriteMembers(OutputFile *f)
bool ReadMembers(InputFile *f, double format)
bool SetAssocSubject(AssocList *)
bool SetReferences(AssocList *)
bool CheckReferences()
void SetTextShape()
bool GetLine(int x, int y)
unsigned int GetLineNumber()
void SetLineNumber(unsigned int n)
TextShape* ChooseTextShape(int x, int y)
virtual void MoveRaw(const Point *delta)
Point GiveOrthoSnp(Point to) const
Point GiveSnp(Point to) const
Point GiveSnp(Point p, int order, int count, int &code)
void UpdateNameDirection(ReadDirection::Type nd)
ReadDirection::Type GetNameDirection() const

### Protected Fields

static const int LINE_DIST
static const int CL_DISTX
static const int CL_DISTY

### Protected Methods

void DrawShape()
void CalcPositionName()
bool ContainsPtLine(int x, int y, const Point *from, const Point *to, int &cx, int &cy) const
bool BelowLine(int x, int y, Point *from, Point *to)
bool AboveLine(int x, int y, Point *from, Point *to)
void SetNameDirection(ReadDirection::Type nd)
void UndrawDirection()
void DrawDirection()
void NotifyTextMove(TextShape *t)

### Inherited from GShape:

### Public Methods

void Draw()
void Undraw()
virtual void UndrawShape()
virtual void DrawTextShapes()
virtual void UndrawTextShapes()
virtual void UpdateNameString(const string *s)
void SetNameString(const string *s)
const string* GetNameString()
TextShape* GetName() const
virtual void SetSelect(bool s)
unsigned GetLineWidth() const
void SetLineWidth(unsigned n)
void UpdateLineWidth(unsigned n)
LineStyle::Type GetLineStyle() const
void SetLineStyle(LineStyle::Type x)
void UpdateLineStyle(LineStyle::Type x)
const string* GetTextColor() const
void UpdateTextColor(const string *c)
virtual TextShape* HitTextShape(int x, int y)
bool HasTextShape(TextShape *t) const
bool IsFixedName()
void SetFixedName(bool b)
void SetGrafport(Grafport *g)
void SetView(ShapeView *v)
virtual void UpdateFont(XFont *ft)
virtual void UpdateAlignment(TextAlign::Type alignment)
XFont* GetFont() const
TextAlign::Type GetAlignment() const
bool HasNameString(const string *s, bool c1, bool c2) const
bool HasString(const string *s, bool c1, bool c2) const
bool HasString(const string *s, bool cI, bool aS, List<TextShape *> *l)

### Protected Methods

virtual void SetFont(XFont *ft)
virtual void SetTextColor(const string *c)
void WriteGraphicsPart(OutputFile *ofile)
bool ReadGraphicsPart(InputFile *ifile, double format)
void WriteTextPart(OutputFile *ofile)
bool ReadTextPart(InputFile *ifile, double format)
void SetDrawAttributes()
virtual void SetAlignment(TextAlign::Type a)
void SnapPosition()
void SnapTopleft()

### Inherited from Shape:

### Public Fields

static const int MIN_HEIGHT
static const int MIN_WIDTH
static const int HANDLE_WIDTH

### Public Methods

bool IsShape() const
virtual bool IsTextShape() const
virtual void UpdateSize(int w, int h)
virtual void UpdateMove(const Point *delta)
virtual void UpdateSelect(bool s)
virtual void UpdateFirstSelect(bool s)
virtual void UpdateColor(string *color)
virtual void SetFirstSelect(bool s)
bool IsFirstSelected() const
void SetVisible(bool s)
void SetSubject(Subject *s)
Subject* GetSubject() const
ShapeView* GetView() const
void SetColor(const string *c)
const string* GetColor() const
virtual void Move(const Point *delta)
virtual void AdjustSize()
void SetHandles(int n)
const Point* GetPosition() const
const Point* GetTopLeft() const
bool IsSelected() const
bool IsVisible() const
bool IsDuplicate() const
int GetWidth() const
int GetHeight() const
virtual void DrawDuplicate()
void UndrawDuplicate()
void SetDuplicate(bool b)
void UpdateDuplicate(bool b)
bool SetAssocView(AssocList *)

### Protected Fields

static const int MIN_HANDLES

### Protected Methods

Grafport* GetGrafport() const
void SetOutlineAttributes()
virtual void SetSize(int w, int h)
void SetWidth(int w)
void SetHeight(int h)
void SetNrHandles(int n)
DiagramViewer* GetViewer() const
void PositiveCoord(const Point*)
virtual void DrawSelect()
virtual void DrawGraySelect()
virtual void UndrawSelect()
virtual void UndrawGraySelect()
void SetTopLeft(const Point *topLeft)
virtual void SetPositionHandles()
void ForcePosition(const Point *position)

### Inherited from Thing:

### Public Classes

enum AssocType

### Public Methods

unsigned long GetId()
void SetId(unsigned long val)
virtual bool IsSubject() const
virtual bool IsView() const
void Write(OutputFile *ofile)

## Documentation

> An arrow with some kind of lightning flash.

`FlashArrow(ShapeView *s, Grafport *g, GShape *n1, GShape *n2, List<Point *> *line, bool Curved)`

`FlashArrow(ShapeView *v, Grafport *g, GShape *n1, GShape *n2, bool Curved)`

`Shape* Clone()`

`int GetClassType() const`

`void DrawLine(const Point *ep1, const Point *ep2)`

`void DrawBezier(const Point *ep1, const Point *ep2)`

`void DrawLinePart()`

This class has no child classes.

alphabetic index hierarchy of classes

this page has been generated automatically by doc++

(c)opyright by Malte Zöckler, Roland Wunderling
contact: doc++@zib.de